SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET search_path = setting, log, pg_catalog;

CREATE OR REPLACE FUNCTION add_cc_cfg_xcloud_platform( varchar, varchar, varchar ) RETURNS VOID AS
$$
BEGIN
	SET search_path = setting, log, pg_catalog;
	UPDATE cc_cfg_xcloud_platform SET cloud_platform_name=$2, description=$3 WHERE cloud_platform_id=$1;
	INSERT INTO cc_cfg_xcloud_platform (cloud_platform_id, cloud_platform_name, description)
		SELECT $1, $2, $3 WHERE NOT EXISTS (SELECT 1 FROM cc_cfg_xcloud_platform WHERE cloud_platform_id=$1);
END
$$ LANGUAGE plpgsql;

SELECT add_cc_cfg_xcloud_platform('AWS','Amazon Web Services','http://aws.amazon.com/jp/');

DROP FUNCTION add_cc_cfg_xcloud_platform( varchar, varchar, varchar );


CREATE OR REPLACE FUNCTION add_cc_collector_platform_mst( varchar, varchar, integer ) RETURNS VOID AS
$$
BEGIN
	SET search_path = setting, log, pg_catalog;
	UPDATE cc_collector_platform_mst SET platform_name=$2, order_no=$3 WHERE platform_id=$1;
	INSERT INTO cc_collector_platform_mst (platform_id, platform_name, order_no)
		SELECT $1, $2, $3 WHERE NOT EXISTS (SELECT 1 FROM cc_collector_platform_mst WHERE platform_id=$1);
END
$$ LANGUAGE plpgsql;

SELECT add_cc_collector_platform_mst('AWS','Amazon Web Services',110);
SELECT add_cc_collector_platform_mst('RDS','Amazon Relational Database Service',110);
SELECT add_cc_collector_platform_mst('ELB','Amazon Elastic Load Balancing',110);

DROP FUNCTION add_cc_collector_platform_mst( varchar, varchar, integer );


CREATE OR REPLACE FUNCTION add_cc_collector_sub_platform_mst( varchar, varchar, varchar, integer ) RETURNS VOID AS
$$
BEGIN
	SET search_path = setting, log, pg_catalog;
	UPDATE cc_collector_sub_platform_mst SET sub_platform_name=$2, type=$3, order_no=$4 WHERE sub_platform_id=$1;
	INSERT INTO cc_collector_sub_platform_mst (sub_platform_id, sub_platform_name, type, order_no)
		SELECT $1, $2, $3, $4 WHERE NOT EXISTS (SELECT 1 FROM cc_collector_sub_platform_mst WHERE sub_platform_id=$1);
END
$$ LANGUAGE plpgsql;

SELECT add_cc_collector_sub_platform_mst('AWS','Amazon Web Services','Cloud',110);

DROP FUNCTION add_cc_collector_sub_platform_mst( varchar, varchar, varchar, integer );
